import xml.dom.minidom,quipple,pdb

def childElts(node):
    return [elt for elt in node.childNodes if elt.nodeType==elt.ELEMENT_NODE]

def htmlToBodyTags(htmlNode):
    if htmlNode.nodeType==htmlNode.ELEMENT_NODE:
        return quipple.BodyTag(htmlNode.nodeName.split(':')[-1],
                               map(htmlToBodyTags,
                                   htmlNode.childNodes))
    else:
        if htmlNode.nodeType in [htmlNode.TEXT_NODE,
                                 htmlNode.CDATA_SECTION_NODE]:
            return htmlNode.nodeValue

def value(elt):
    return ''.join(map(lambda c: c.nodeValue,elt.childNodes))

def parseQuote(quoteElt):
    cite=None
    tags=[]
    body=[]
    for child in quoteElt.childNodes:
        if child.nodeType!=child.ELEMENT_NODE:
            continue

        if child.namespaceURI==quipple.jquoteNamespace:
            if child.nodeName=='attribution':
                cite=value(child)
                continue

            if child.nodeName=='categories':
                for category in child.childNodes:
                    if category.nodeType!=child.ELEMENT_NODE:
                        continue
                    tags.append(value(category))
                    continue

            if child.nodeName=='text':
                body=[value(child)]
                continue
    return quipple.Quip(body,cite=cite,tags=tags)

def parse(parseable):
    parseFunction=xml.dom.minidom.parse
    if isinstance(parseable,tuple):
        (kind,arg)=parseable
        if kind=='body':
            parseFunction=xml.dom.minidom.parseString
        parseable=arg
    d=parseFunction(parseable)
    root=d.firstChild
    return filter(None,
                  map(parseQuote,
                      childElts(filter(lambda elt: (
                        elt.nodeType==elt.ELEMENT_NODE
                        and elt.nodeName=='quotes'
                        ),
                                       root.childNodes)[0]
                                )
                      )
                  )
