import quipple,quipple.parse,itertools

class Source(object):
    def all(self):
        pass

    def search(self,query):
        return query.search(self.all())

    def filter(self,query):
        return Filtered(self,query)

    def uri(self):
        pass

    def toXML(self,src=None):
        return quipple.quipsToXML(self.all(),src=src)

class Filtered(Source):
    def __init__(self,src,query):
        self.src=src
        self.query=query

    def all(self):
        return self.src.search(self.query)

class ListSource(Source):
    def __init__(self,quips):
        self.quips=list(quips)

    def all(self):
        return iter(self.quips)

class XmlSource(ListSource):
    def __init__(self,parseable):
        ListSource.__init__(self,quipple.parse.parse(parseable))

class Aggregator(Source):
    def __init__(self,sources=None):
        self.sources=sources or []

    def addSource(self,source):
        self.sources.append(source)

    def all(self):
        alls=map(lambda s: s.all(),self.sources)
        return itertools.chain(*alls)

    def search(self,query):
        searches=map(lambda s: query.search(s),self.sources)
        return query.search(itertools.chain(*searches))


class RemoteSource(Source):
    def __init__(self,baseUrl):
        self.baseUrl=baseUrl

    def fetch(url):
        return XmlSource(('url',url)).all()

    def uri(self):
        return self.baseUrl

    def all(self):
        return fetch(self.baseUrl)

    def search(self,query):
        return fetch(self.baseUrl+'?'+query.toCGI())
